/***************************************************************************
****************************************************************************

This is a part of the xModule Source code.

Copyright (C) 2003-2005 The LS-Universe Team

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.

****************************************************************************
****************************************************************************/

#if !defined(AFX_DESKTOPTEXTURE_H__DF589CF7_3C13_487E_A0B3_34ADA89C0C81__INCLUDED_)
#define AFX_DESKTOPTEXTURE_H__DF589CF7_3C13_487E_A0B3_34ADA89C0C81__INCLUDED_

typedef list<COLORREF> ColorRefList;
typedef list<COLORREF>::iterator ColorRefListIterator;

class DesktopTexture
{
public:

	DesktopTexture();
	virtual ~DesktopTexture();

	void configure(const string &groupname);
	void apply(HDC hDC, int x, int y, int width, int height, POINT size, const string &iconCommand, const string &uniquekey, bool activated);

private:

	void parseCFG(string cfg, COLORREF &bgcolor, COLORREF &lightcolor, COLORREF &darkcolor);
	void parseGradientCFG(string cfg, int imageType);

	void solidGradientPaint(HDC destHDC, ColorRefList workGradient, RECT r, bool vertical, int repeated);
	
	HICON applyIconEffects(HICON hIcon, bool active, bool systemactive = false);

	bool useNoIcon;
	bool useSmallIcon;

	string linkOverlayIcon;
	HICON linkIcon;
	HICON activelinkIcon;

	bool noActiveIconColor;

	int iconSize;
	int iconTextPosition;
	int iconTextSpacing;

	ColorRefList NormalGradient;
	ColorRefList ActiveGradient;

	bool normalverticalGradient;
	bool activeverticalGradient;

	int normalrepeatedGradient;
	int activerepeatedGradient;

	COLORREF iconTextBackground;
	COLORREF iconTextBackgroundLight;
	COLORREF iconTextBackgroundDark;

	COLORREF activeiconTextBackground;
	COLORREF activeiconTextBackgroundLight;
	COLORREF activeiconTextBackgroundDark;

	int normal_saturation;
	int normal_hueIntensity;
	COLORREF normal_hueColor;

	int active_saturation;
	int active_hueIntensity;
	COLORREF active_hueColor;
};

#endif // !defined(AFX_DESKTOPTEXTURE_H__DF589CF7_3C13_487E_A0B3_34ADA89C0C81__INCLUDED_)
